PAGE 60,132
TITLE IsDate.Asm  Display Extended Date Info

; Syntax:  IsDate

;      (c) 1994  Ben Ritchey Jr., et al
;                Propriety: Licensed Use Only 

.8086  ; 8086 thru 80486 OK
               DOSSEG
               .MODEL  small
               .STACK  400h    ;1K
               INCLUDE macro.inc
 
; Data & Constants
               .DATA
RC             DB      0
RUNDS          DW      0
RUNES          DW      0

               .CODE
BIOS           EQU     10h
DOS            EQU     21h     ;DOS Sys Func Req

START:         mov     ax,@data  ;Data Seg Addr
               mov     ds,ax
               mov     RUNDS,ax
               mov     es,ax     ;Extra Seg=Data
               mov     RUNES,ax
               cli               ;Stack Seg=Data
               mov     ss,ax
               mov     sp,OFFSET STACK
               sti

               call    GET_DTE
               mov     dx,OFFSET THEDATE
               @PUT_STR
               mov     al,[BIN_DATE+2]  ;RC=Day
               mov     RC,al

EXIT:          mov     al,RC   ;ErrorLevel
               mov     ah,4Ch  ; Return/Exit
               int     DOS
               ret

;
; GET_DTE  Get System Date
;  Out       ASC_DATE = ASCII Date (dow mmm dd yyyy jjj)
;            BIN_DATE = Binary Date (wmdyyjj)
;            BCD_DATE = Packed BCD Date (mdy)

               .DATA
BIN_DATE       DB      7 DUP(0)  ;WMDYYJJ
THEDATE        DB      13, 10, 'Today is  '
ASC_DATE       DB      'dow  mmm dd yyyy  jjj' ;ASCII
ASC_DATEL      EQU     $-ASC_DATE
               DB      13, 10, '$'
BCD_DATE       DB      3 DUP(0)  ;MDY
LEAP_FLAG      DW      0       ;1=Leap Year

               .CONST
MONTABLE       DB      'JanFebMarAprMayJunJulAugSepOctNovDec'
DOWTABLE       DB      'SunMonTueWedThuFriSat'
JULTABLE       DW      0,31,59,90,120,151,181,212,243,273,304,334

               .CODE
GET_DTE        LABEL   PROC
               call    SAVE_REGS
               mov     ah,2Ah          ;Get DOS Date
               int     DOS
               mov     bx,OFFSET BIN_DATE ;Save Bin Date
               mov     [bx],al         ; Dow (0-6, 0=Sun)
               mov     [bx+1],dh       ; MM (1-12)
               mov     [bx+2],dl       ; DD (1-31)
               mov     [bx+3],cx       ; YYYY (1980-2099)
               push    dx
               xor     dx,dx
               mov     ax,cx           ;Leap Year?
               mov     cx,4
               div     cx
               cmp     dx,0
               jnz     @F              ; No
               mov     LEAP_FLAG,1     ; Yes
@@:            xor     ah,ah           ;Calc Bin Julien
               pop     dx
               mov     al,dh
               dec     al
               mov     cl,2
               mul     cl
               mov     si,ax
               mov     cx,[JULTABLE][si]
               cmp     dh,3
               jb      @F
               add     cx,LEAP_FLAG    ;Mar-Dec
@@:            xor     dh,dh
               add     cx,dx
               mov     WORD PTR [BIN_DATE+5],cx
               xor     ah,ah           ;Set Dow
               mov     al,BIN_DATE
               mov     cl,3
               mul     cl
               mov     si,OFFSET DOWTABLE
               add     si,ax
               mov     di,OFFSET ASC_DATE
               cld
               mov     cx,3
               rep     movsb
               inc     di
               inc     di
               xor     ah,ah           ;Set Month
               mov     al,[BIN_DATE+1]
               dec     al
               mov     cl,3
               mul     cl
               mov     si,OFFSET MONTABLE
               add     si,ax
               mov     cx,3
               rep     movsb
               inc     di
               mov     al,[BIN_DATE+2]       ;Set Day
               mov     ZBYTE,al
               call    BIN_DEC1
               mov     ax,WORD PTR [DECIMAL+6]
               mov     [di], ax
               add     di,3
               mov     ax, WORD PTR [BIN_DATE+3] ;Set Year
               mov     ZWORD,ax
               call    BIN_DEC2
               lea     si,DECIMAL+4
               mov     cx,4
               rep     movsb
               inc     di
               inc     di
               mov     ax,WORD PTR [BIN_DATE+5]       ;Set Julien
               mov     ZWORD,ax
               call    BIN_DEC2
               lea     si,DECIMAL+5
               mov     cx,3
               rep     movsb
               mov     al,[BIN_DATE+1]         ;Calc BCD Month
               mov     ZBYTE,al
               call    BIN_DEC1
               mov     cl,4
               mov     ah,[DECIMAL+6]
               sub     ah,48
               shl     ah,cl
               mov     al,[DECIMAL+7]
               sub     al,48
               add     al,ah
               mov     BCD_DATE,al
               mov     ah,[ASC_DATE+8]         ;Calc BCD Day
               sub     ah,48
               shl     ah,cl
               mov     al,[ASC_DATE+9]
               sub     al,48
               add     al,ah
               mov     [BCD_DATE+1],al
               mov     ah,[ASC_DATE+13]        ;Calc BCD Year
               sub     ah,48
               shl     ah,cl
               mov     al,[ASC_DATE+14]
               sub     al,48
               add     al,ah
               mov     [BCD_DATE+2],al
               call    REST_REGS
               ret

; BIN_DEC1  Convert Binary to ASCII Decimal
;  In        ZBYTE = Bin Val (hh)
;  Out       DECIMAL+5 = ASCII Dec (nnn)
               .DATA
ZBYTE          DB      0
DECIMAL        DB      8 DUP('0'),0

               .CONST
HEXTABLE       DB      '0123456789ABCDEF'

               .CODE
BIN_DEC1       LABEL   PROC
               call    SAVE_REGS
               xor     ax,ax
               xor     bx,bx
               mov     al,ZBYTE
               mov     cx,100          ;Hunds
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+5,al
               mov     al,ah           ;Tens
               xor     ah,ah
               mov     cx,10
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+6,al
               mov     bl,ah           ;Ones
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+7,al
               call    REST_REGS
               ret

; BIN_DEC2  Convert Binary to ASCII Decimal
;  In        ZWORD = Bin Val (hhhh)
;  Out       DECIMAL+3 = ASCII Dec (nnnnn)
               .DATA
ZWORD          DW      0
               .CODE
BIN_DEC2       LABEL   PROC
               call    SAVE_REGS
               xor     bx,bx
               xor     dx,dx
               mov     ax,ZWORD
               mov     cx,10000        ;Ten Thous
               div     cx
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+3,al
               mov     ax,dx           ;Thous
               xor     dx,dx
               mov     cx,1000
               div     cx
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+4,al
               mov     ax,dx           ;Hunds
               mov     cx,100
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+5,al
               mov     al,ah           ;Tens
               xor     ah,ah
               mov     cx,10
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+6,al
               mov     bl,ah     ;Ones
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+7,al
               call    REST_REGS
               ret

; SAVE_REGS / REST_REGS
;  Save/Restore ax, cx, dx, bx, bp, si, di, ds, es

               .DATA
IRADDR         DW      IRDATA  ;Reg Save Index
IRDATA         DW      90 DUP(0)  ;Reg Save Table

               .CODE
SAVE_REGS      LABEL   PROC
               push    bx
               mov     bx,IRADDR
               mov     [bx],ax
               mov     [bx+2],cx
               mov     [bx+4],dx
               pop     ax
               push    ax
               mov     [bx+6],ax
               mov     [bx+8],bp
               mov     [bx+10],si
               mov     [bx+12],di
               mov     [bx+14],ds
               mov     [bx+16],es
               add     bx,18
               mov     IRADDR,bx
               pop     bx
               ret

REST_REGS      LABEL   PROC
               mov     ax,SEG IRADDR
               mov     ds,ax
               mov     bx,IRADDR
               sub     bx,18
               mov     IRADDR,bx
               mov     ax,[bx]
               push    ax
               mov     cx,[bx+2]
               mov     dx,[bx+4]
               mov     bp,[bx+8]
               mov     si,[bx+10]
               mov     di,[bx+12]
               mov     ax,[bx+14]
               mov     ds,ax
               mov     ax,[bx+16]
               mov     es,ax
               mov     ax,[bx+6]
               mov     bx,ax
               pop     ax
               ret
               END     START
;*** End of Program ***
